Attribute VB_Name = "EnumFileSystem"
'Modified a lot
'originally by Sean P. Moffett (sean AT exis.net)

Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long

Private Const DRIVE_CDROM = 5
Private Const DRIVE_FIXED = 3
Private Const DRIVE_RAMDISK = 6
Private Const DRIVE_REMOTE = 4
Private Const DRIVE_REMOVABLE = 2
Private Const vbAllFileSpec = "*.*"

Private Const MAX_PATH = 260

Private Type FILETIME
dwLowDateTime As Long
dwHighDateTime As Long
End Type
Dim hFind As Long
Private Type WIN32_FIND_DATA   'wfd
dwFileAttributes As Long
ftCreationTime As FILETIME
ftLastAccessTime As FILETIME
ftLastWriteTime As FILETIME
nFileSizeHigh As Long
nFileSizeLow As Long
dwReserved0 As Long
dwReserved1 As Long
cFileName As String * MAX_PATH
cShortFileName As String * 14
End Type

Private wfd As WIN32_FIND_DATA
Private Const INVALID_HANDLE_VALUE = -1
Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long

Private lNodeCount As Long

Private Const vbBackslash = "\"
Private Const vbAscDot = 46


Public Function Enum_Drives() As String
On Error Resume Next
'***********************************************************************'
'Purpose:Returns all drives on current system.
'
'1)Each drive is seperated by a "|".
'2)The Drive Letter and Type are seperated by a ",".
'***********************************************************************'
Dim strDrive    As String
Dim strMessage  As String
Dim intCnt      As Integer
Dim rtn As String

strMessage = ""

For intCnt = 65 To 86
strDrive = Chr(intCnt)
Select Case GetDriveType(strDrive + ":\")
Case DRIVE_REMOVABLE
rtn = "Floppy Drive"
Case DRIVE_FIXED
rtn = "Hard Drive"
Case DRIVE_REMOTE
rtn = "Network Drive"
Case DRIVE_CDROM
rtn = "CD-ROM Drive"
Case DRIVE_RAMDISK
rtn = "RAM Disk"
Case Else
rtn = ""
End Select

If rtn <> "" Then
strMessage = strMessage & strDrive & "," & GetDriveType(strDrive + ":\") & "|"
End If

Next intCnt
Enum_Drives = Mid$(strMessage, 1, Len(strMessage) - 1)

End Function

Function ParseString(ByVal sString As String, ByVal Delimiter As String) As Collection
On Error Resume Next
'*********************************************************************************************
'Description: Parses string with a specified delimiter.
'*********************************************************************************************

On Error GoTo ParseString_Error


Dim CurPos       As Long
Dim NextPos      As Long
Dim DelLen       As Integer
Dim nCount       As Integer
Dim TStr         As String

Set ParseString = New Collection

' Add delimiters to start and end of string to make loop simpler:
sString = Delimiter & sString & Delimiter
' Calculate the delimiter length only once:
DelLen = Len(Delimiter)
' Initialize the count and position:
nCount = 0
CurPos = 1
NextPos = InStr(CurPos + DelLen, sString, Delimiter)

' Loop searching for delimiters:
Do Until NextPos = 0
' Extract a sub-string:
ParseString.Add Mid$(sString, CurPos + DelLen, NextPos - CurPos - DelLen)
' Increment the sub string counter:
nCount = nCount + 1

' Position to the last found delimiter:
CurPos = NextPos
' Find the next delimiter:
NextPos = InStr(CurPos + DelLen, sString, Delimiter)
Loop


ParseString_Exit:
Exit Function

ParseString_Error:
Err.Raise Err.Number, "ParseString"
Exit Function

End Function



Public Function Enum_Files(sParentPath As String) As String

On Error Resume Next
Dim wfd As WIN32_FIND_DATA
Dim hFind As Long
Dim strString As String
Dim sFileName As String

strString = ""

sParentPath = NormalizePath(sParentPath)

hFind = FindFirstFile(sParentPath & "\" & vbAllFileSpec, wfd)
If (hFind <> INVALID_HANDLE_VALUE) Then

Do

sFileName = Left$(wfd.cFileName, InStr(wfd.cFileName, vbNullChar) - 1)

If sFileName <> "." And sFileName <> ".." Then
If wfd.dwFileAttributes <> vbDirectory Then
strString = strString & sParentPath & Left$(wfd.cFileName, InStr(wfd.cFileName, vbNullChar) - 1) & "|"
End If
End If

Loop While FindNextFile(hFind, wfd)

Call FindClose(hFind)
End If
If strString <> "" Then
Enum_Files = Mid$(strString, 1, Len(strString) - 1)
Else
Enum_Files = strString
End If

End Function


Public Function NormalizePath(sPath As String) As String
On Error Resume Next
If Right$(sPath, 1) <> "\" Then
NormalizePath = sPath & "\"
Else
NormalizePath = sPath
End If
End Function



Public Function Enum_Folders(sParentPath As String) As String
On Error Resume Next
Dim strMessage  As String
Dim wfd As WIN32_FIND_DATA
Dim hFind As Long

sParentPath = NormalizePath(sParentPath)

hFind = FindFirstFile(sParentPath & vbAllFileSpec, wfd)
If (hFind <> INVALID_HANDLE_VALUE) Then

Do

If (wfd.dwFileAttributes And vbDirectory) Then
' If not a  "." or ".." DOS subdir...
If (Asc(wfd.cFileName) <> vbAscDot) Then
strMessage = strMessage & Mid$(wfd.cFileName, 1, InStr(wfd.cFileName, vbNullChar) - 1) & "|"
End If
End If

Loop While FindNextFile(hFind, wfd)

Call FindClose(hFind)
End If


Screen.MousePointer = vbDefault
If strMessage <> "" Then
Enum_Folders = Mid$(strMessage, 1, Len(strMessage) - 1)
Else
Enum_Folders = ""
End If
End Function

